import { openBlock as n, createElementBlock as a, createElementVNode as o, renderSlot as r, ref as V, computed as f, normalizeClass as b, unref as c, createVNode as x, withCtx as m, resolveComponent as w, createBlock as k, inject as q, withDirectives as B, isRef as $, vModelDynamic as L, toDisplayString as _, createCommentVNode as y, provide as D, Fragment as C, renderList as z, onMounted as M, withModifiers as S, createTextVNode as T, vModelSelect as U, vModelText as O, vModelCheckbox as P } from "vue";
const N = (l, t) => {
  const e = l.__vccOpts || l;
  for (const [s, d] of t)
    e[s] = d;
  return e;
}, Z = {}, E = { class: "cf-app-bar" };
function j(l, t) {
  return n(), a("header", E, [
    o("div", null, [
      r(l.$slots, "left")
    ]),
    o("div", null, [
      r(l.$slots, "right")
    ])
  ]);
}
const G = /* @__PURE__ */ N(Z, [["render", j]]);
const R = { class: "cf-dropdown-body" }, H = {
  __name: "Dropdown",
  setup(l) {
    const t = V(!1), e = f(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (s, d) => (n(), a("div", {
      class: b(c(e))
    }, [
      o("div", {
        class: "cf-dropdown-toggle",
        onClick: d[0] || (d[0] = (i) => t.value = !t.value)
      }, [
        r(s.$slots, "toggle")
      ]),
      o("div", R, [
        r(s.$slots, "body")
      ]),
      o("div", {
        class: "cf-dropdown-backdrop",
        onClick: d[1] || (d[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const X = {
  key: 0,
  class: "cf-app-bar-link"
}, J = { class: "cf-app-bar-link__label" }, K = /* @__PURE__ */ o("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ o("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), Q = {
  key: 1,
  class: "cf-app-bar-link"
}, W = { class: "cf-app-bar-link__label" }, _t = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(l) {
    return (t, e) => l.dropdown ? (n(), a("div", X, [
      x(H, null, {
        toggle: m(() => [
          o("div", J, [
            r(t.$slots, "default"),
            K
          ])
        ]),
        body: m(() => [
          r(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (n(), a("button", Q, [
      o("div", W, [
        r(t.$slots, "default")
      ])
    ]));
  }
};
const pt = {
  __name: "AppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(l) {
    const t = l, e = f(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": t.wide
    }));
    return (s, d) => (n(), a("div", {
      class: b(c(e))
    }, [
      r(s.$slots, "default")
    ], 2));
  }
};
const ft = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(l) {
    const t = l, e = f(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (s, d) => (n(), a("div", {
      class: b(c(e))
    }, [
      r(s.$slots, "default")
    ], 2));
  }
}, F = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: {
    type: Boolean,
    default: !1
  },
  wide: {
    type: Boolean,
    default: !1
  },
  color: {
    type: String,
    default: null
  },
  loading: {
    type: Boolean,
    default: !1
  },
  disabled: {
    type: Boolean,
    default: !1
  }
};
const Y = ["type", "disabled"], vt = {
  __name: "FilledButton",
  props: F,
  setup(l) {
    const t = l, e = f(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (s, d) => {
      const i = w("router-link");
      return s.to ? (n(), k(i, {
        key: 0,
        class: b(c(e)),
        to: s.to,
        inert: t.disabled
      }, {
        default: m(() => [
          r(s.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (n(), a("button", {
        key: 1,
        class: b(c(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        r(s.$slots, "default")
      ], 10, Y));
    };
  }
};
const ee = ["type", "disabled"], bt = {
  __name: "OutlinedButton",
  props: F,
  setup(l) {
    const t = l, e = f(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (s, d) => {
      const i = w("router-link");
      return s.to ? (n(), k(i, {
        key: 0,
        class: b(c(e)),
        to: s.to,
        inert: t.disabled
      }, {
        default: m(() => [
          r(s.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (n(), a("button", {
        key: 1,
        class: b(c(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        r(s.$slots, "default")
      ], 10, ee));
    };
  }
};
const te = ["disabled"], mt = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(l) {
    const t = l;
    return (e, s) => {
      const d = w("router-link");
      return l.to ? (n(), k(d, {
        key: 0,
        class: "cf-text-button",
        to: l.to,
        inert: t.disabled
      }, {
        default: m(() => [
          r(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (n(), a("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        r(e.$slots, "default")
      ], 8, te));
    };
  }
};
const le = { class: "cf-choice" }, se = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], oe = ["for"], ne = { key: 0 }, ae = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, s = Math.random(), d = {
      name: q("choice-list-name", null),
      required: q("choice-list-required", null)
    }, i = f({
      get() {
        return e.modelValue;
      },
      set(u) {
        t("update:modelValue", u);
      }
    });
    return (u, v) => (n(), a("div", le, [
      B(o("input", {
        "onUpdate:modelValue": v[0] || (v[0] = (g) => $(i) ? i.value = g : null),
        type: e.type,
        id: c(s),
        name: d.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: d.required,
        disabled: e.disabled
      }, null, 8, se), [
        [L, c(i)]
      ]),
      o("label", { for: c(s) }, _(e.label || e.value), 9, oe),
      e.helper ? (n(), a("small", ne, _(e.helper), 1)) : y("", !0)
    ]));
  }
};
const de = {
  key: 0,
  class: "cf-choice-list__label"
}, yt = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, s = f(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), d = f({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return D("choice-list-name", Math.random()), D("choice-list-required", e.required), (i, u) => (n(), a("div", {
      class: b(c(s))
    }, [
      e.label ? (n(), a("div", de, _(e.label), 1)) : y("", !0),
      (n(!0), a(C, null, z(l.choices, (v) => (n(), k(ae, {
        key: v.value || v,
        type: e.multiple ? "checkbox" : "radio",
        label: v.label || v.value || v,
        helper: v.helper,
        value: v.value || v,
        disabled: e.disabled,
        modelValue: c(d),
        "onUpdate:modelValue": u[0] || (u[0] = (g) => $(d) ? d.value = g : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128))
    ], 2));
  }
};
const ie = { class: "cf-sidebar-nav" }, re = /* @__PURE__ */ o("hr", null, null, -1), ue = /* @__PURE__ */ o("span", { class: "material-symbols-outlined" }, null, -1), ce = /* @__PURE__ */ o("span", null, "Collapse sidebar", -1), _e = [
  ue,
  ce
], pe = {
  __name: "Sidebar",
  setup(l) {
    const t = V(!1), e = f(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (s, d) => (n(), a("aside", {
      class: b(c(e))
    }, [
      o("nav", ie, [
        r(s.$slots, "default"),
        re
      ]),
      o("button", {
        class: "cf-sidebar-toggle",
        onClick: d[0] || (d[0] = (i) => t.value = !t.value)
      }, _e)
    ], 2));
  }
};
const ht = {
  __name: "DefaultLayout",
  setup(l) {
    return M(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (n(), a(C, null, [
      x(G, null, {
        left: m(() => [
          r(t.$slots, "brand")
        ]),
        right: m(() => [
          r(t.$slots, "navigation")
        ]),
        _: 3
      }),
      x(pe, null, {
        default: m(() => [
          r(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      o("main", null, [
        r(t.$slots, "main")
      ])
    ], 64));
  }
};
const fe = { class: "cf-dialog-header" }, ve = { key: 0 }, be = { class: "cf-dialog-body" }, me = { class: "cf-dialog-footer" }, ye = /* @__PURE__ */ o("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ o("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), he = [
  ye
], gt = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(l, { emit: t }) {
    const e = l, s = V(null);
    return M(() => s.value.showModal()), (d, i) => (n(), a("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: s
    }, [
      o("div", fe, [
        o("h1", null, _(e.title), 1),
        e.description ? (n(), a("div", ve, _(e.description), 1)) : y("", !0)
      ]),
      o("div", be, [
        r(d.$slots, "body")
      ]),
      o("div", me, [
        r(d.$slots, "footer")
      ]),
      o("button", {
        class: "cf-dialog-close",
        onClick: i[0] || (i[0] = (u) => t("close"))
      }, he)
    ], 512));
  }
};
const ge = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, $e = { class: "material-symbols-outlined" }, ke = { class: "cf-dropdown-item__label" }, Be = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, we = { class: "material-symbols-outlined" }, Se = { class: "cf-dropdown-item__label" }, $t = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(l) {
    const t = l, e = f(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (s, d) => {
      const i = w("router-link");
      return l.to ? (n(), k(i, {
        key: 1,
        class: b(c(e)),
        to: l.to
      }, {
        default: m(() => [
          l.icon ? (n(), a("div", Be, [
            o("span", we, _(l.icon), 1)
          ])) : y("", !0),
          o("div", Se, [
            r(s.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (n(), a("button", {
        key: 0,
        class: b(c(e))
      }, [
        l.icon ? (n(), a("div", ge, [
          o("span", $e, _(l.icon), 1)
        ])) : y("", !0),
        o("div", ke, [
          r(s.$slots, "default")
        ])
      ], 2));
    };
  }
};
const Ve = { class: "cf-drop-zone" }, xe = ["onDrop"], Ce = { class: "cf-drop-zone-box__label" }, qe = { class: "cf-drop-zone-box__action" }, De = /* @__PURE__ */ o("span", null, "select from device", -1), Le = ["required"], ze = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Me = {
  key: 1,
  class: "cf-drop-zone-list"
}, Ne = /* @__PURE__ */ o("div", { class: "cf-drop-zone-list__header" }, null, -1), Fe = { class: "cf-drop-zone-list__item" }, Ae = /* @__PURE__ */ o("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ o("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Ie = [
  Ae
], kt = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(l, { emit: t }) {
    const e = l, s = V(null), d = f(() => !!(e.required && !e.modelValue)), i = f(() => {
      if (e.modelValue) {
        const p = (e.modelValue.size / 1048576).toFixed(0), I = (p / 1e3).toFixed(1);
        return p < 100 ? `${p} MB` : `${I} GB`;
      } else
        return "0 MB";
    }), u = (h) => {
      const p = h.target.files[0];
      g(p);
    }, v = (h) => {
      const p = h.dataTransfer.files[0];
      g(p);
    }, g = (h) => {
      const p = parseInt(e.max) * 1048576;
      p && p < h.size ? (s.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", h), t("add", h));
    }, A = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (h, p) => (n(), a("div", Ve, [
      l.modelValue ? (n(), a("div", Me, [
        Ne,
        o("div", Fe, [
          o("div", null, _(e.modelValue.name), 1),
          o("div", null, _(c(i)), 1),
          o("button", { onClick: A }, Ie)
        ])
      ])) : (n(), a("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: S(v, ["prevent"]),
        onDragenter: p[0] || (p[0] = S(() => {
        }, ["prevent"])),
        onDragover: p[1] || (p[1] = S(() => {
        }, ["prevent"])),
        onDragleave: p[2] || (p[2] = S(() => {
        }, ["prevent"]))
      }, [
        o("div", Ce, _(e.label), 1),
        o("label", qe, [
          T(" Drag and drop or "),
          De,
          o("input", {
            type: "file",
            ref_key: "input",
            ref: s,
            required: c(d),
            onChange: u
          }, null, 40, Le)
        ]),
        e.max ? (n(), a("div", ze, " Files larger than " + _(e.max) + " MB cannot be uploaded ", 1)) : y("", !0)
      ], 40, xe))
    ]));
  }
};
const Te = { class: "cf-field" }, Ue = ["required", "disabled"], Oe = {
  key: 0,
  value: null
}, Pe = ["value"], Ze = ["required", "disabled"], Ee = ["type", "placeholder", "list", "required", "disabled"], je = { key: 3 }, Ge = { key: 4 }, Bt = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    placeholder: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, s = f({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, i) => (n(), a("div", Te, [
      e.type === "select" ? B((n(), a("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": i[0] || (i[0] = (u) => $(s) ? s.value = u : null),
        required: e.required,
        disabled: e.disabled
      }, [
        e.required ? y("", !0) : (n(), a("option", Oe)),
        (n(!0), a(C, null, z(e.options, (u) => (n(), a("option", {
          key: u.value || u,
          value: u.value || u
        }, _(u.label || u), 9, Pe))), 128))
      ], 8, Ue)), [
        [U, c(s)]
      ]) : e.type === "textarea" ? B((n(), a("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": i[1] || (i[1] = (u) => $(s) ? s.value = u : null),
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ze)), [
        [O, c(s)]
      ]) : B((n(), a("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": i[2] || (i[2] = (u) => $(s) ? s.value = u : null),
        type: e.type,
        placeholder: e.placeholder,
        list: e.list,
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ee)), [
        [L, c(s)]
      ]),
      e.label ? (n(), a("label", je, _(e.label), 1)) : y("", !0),
      e.helper ? (n(), a("small", Ge, _(e.helper), 1)) : y("", !0)
    ]));
  }
};
const Re = ["value", "max"], wt = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(l) {
    const t = l;
    return (e, s) => (n(), a("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, _(l.value) + "% ", 9, Re));
  }
};
const He = { class: "cf-sidebar-link__icon" }, Xe = { class: "material-symbols-outlined" }, Je = { class: "cf-sidebar-link__label" }, Ke = ["href"], Qe = { class: "cf-sidebar-link__icon" }, We = { class: "material-symbols-outlined" }, Ye = { class: "cf-sidebar-link__label" }, St = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(l) {
    const t = l;
    return (e, s) => {
      const d = w("router-link");
      return l.to ? (n(), k(d, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: m(() => [
          o("div", He, [
            o("span", Xe, _(l.icon), 1)
          ]),
          o("div", Je, [
            r(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (n(), a("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: l.href
      }, [
        o("div", Qe, [
          o("span", We, _(l.icon), 1)
        ]),
        o("div", Ye, [
          r(e.$slots, "default")
        ])
      ], 8, Ke));
    };
  }
};
const et = {}, tt = { class: "cf-spinner" }, lt = /* @__PURE__ */ o("div", null, null, -1), st = /* @__PURE__ */ o("div", null, null, -1), ot = /* @__PURE__ */ o("div", null, null, -1), nt = /* @__PURE__ */ o("div", null, null, -1), at = [
  lt,
  st,
  ot,
  nt
];
function dt(l, t) {
  return n(), a("div", tt, at);
}
const Vt = /* @__PURE__ */ N(et, [["render", dt]]);
const it = { class: "cf-switch" }, rt = ["value", "true-value", "false-value", "disabled"], ut = {
  key: 0,
  class: "cf-switch__label"
}, xt = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, s = f({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, i) => (n(), a("div", it, [
      B(o("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (u) => $(s) ? s.value = u : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, rt), [
        [P, c(s)]
      ]),
      e.label ? (n(), a("div", ut, _(e.label), 1)) : y("", !0)
    ]));
  }
};
export {
  G as CfAppBar,
  _t as CfAppBarLink,
  pt as CfAppBody,
  ft as CfBanner,
  ae as CfChoice,
  yt as CfChoiceList,
  ht as CfDefaultLayout,
  gt as CfDialog,
  kt as CfDropZone,
  H as CfDropdown,
  $t as CfDropdownItem,
  Bt as CfField,
  vt as CfFilledButton,
  bt as CfOutlinedButton,
  wt as CfProgress,
  pe as CfSidebar,
  St as CfSidebarLink,
  Vt as CfSpinner,
  xt as CfSwitch,
  mt as CfTextButton
};
